function setLabel(lab, txt)
{
  var cn = lab.childNodes;
  while (cn.length)
    lab.removeChild(cn[0]);
  if (txt != null)
  {
    var tn = lab.ownerDocument.createTextNode(txt);
    lab.appendChild(tn);
  }
}

function CompareObjects(obj1, obj2)
{
  try
  {
    if (obj1 == obj2)
      return true;
    obj1 = obj1.QueryInterface(Components.interfaces.IWrappedPCM);
    obj2 = obj2.QueryInterface(Components.interfaces.IWrappedPCM);
    if (!obj1 || !obj2)
      return false;
    return obj1.objid == obj2.objid;
  }
  catch (e)
  {
    return false;
  }
}

function Objid(obj)
{
  return obj.QueryInterface(Components.interfaces.IWrappedPCM).objid;
}

function randomCmeta()
{
  var alphabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
  var allvalid = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-" +
        "_{}[]/?;:~`!@$^*()+=|\\";
  var l = 10, i;
  var s = alphabet[parseInt(Math.random() * alphabet.length)];
  for (i = 0; i < l; i++)
    s = s + allvalid[parseInt(Math.random() * allvalid.length)];
  return s;
}

function recursivelyCloneImports(model, cloned)
{
  // Pre-condition: model and cloned are exact copies of each other.

  // We asusme the order is unchanged as a side effect of the precondition.
  var impsetModel = model.imports.iterateImports();
  var impsetClone = cloned.imports.iterateImports();

  var impModel;
  while ((impModel = impsetModel.nextImport()) != null)
  {
    var impClone = impsetClone.nextImport();

    if (impModel.importedModel == null)
      TagWithName(cloned, "import_load_failed");
    else
    {
      impClone.instantiateFromText(impModel.importedModel.serialisedText);
      recursivelyCloneImports(impModel.importedModel, impClone.importedModel);
      
      if (IsTagged(impClone.importedModel, "import_load_failed"))
        TagWithName(cloned, "import_load_failed");
    }
  }
}

// Normal clones don't clone imports. This clones imports as well...
function deepCloneModel(model)
{
  var cloned = model.clone(true).QueryInterface(Components.interfaces.cellml_apiIModel);
  recursivelyCloneImports(model, cloned);
  return cloned;
}

window.roundToDecimalPoint = function(fp, digits)
{
  var t = "" + fp;

  var dpi = t.indexOf(".");
  if (dpi < 0)
    return t;

  if (dpi + digits + 1 >= t.length)
    return t;

  var tt = t.substr(0, dpi + digits);
  var dlast = parseInt(t[dpi + digits]);
  var dextra = parseInt(t[dpi + digits + 1]);
  if (dextra < 5)
  {
    return tt + dlast;
  }
  else
  {
    var extrazeros = "";
    var sawDot = false;
    while (dlast == 9)
    {
      if (sawDot)
      {
        extrazeros = extrazeros + "0";
        if (tt == "")
          return "1" + extrazeros;
      }
      dlast = parseInt(tt[tt.length - 1]);
      if (!isFinite(dlast))
      {
        sawDot = true;
        tt = tt.substr(0, tt.length - 1);
        dlast = parseInt(tt[tt.length - 1]);
      }
      tt = tt.substr(0, tt.length - 1);
    }
    // XXX -3.15 => -3.1...
    return tt + (dlast + 1) + extrazeros;
  }
}
